void MenuWerteSetzen()
{
  //Grundeinstellung & Datum
  if (MenuTiefe == 3 && MenuEbene0 == 1 && MenuEbene1 == 1)
  {
    lcd.blink();
    if (FirstSelect)
    {
      setDisplayDate(-1, 6, 1);
      FirstSelect = false;
    }
    else
      setDisplayDate(key, 6, 1);
  }  

  //Grundeinstellung & Uhrzeit
  if (MenuTiefe == 3 && MenuEbene0 == 1 && MenuEbene1 == 2)
  {
    lcd.blink();
    if (FirstSelect)
    {
      rtcClock = rtc.getTime();
      rtcClock = setDisplayTime(-1, rtcClock, 11, 1);
      FirstSelect = false;
    }
    else
    {
      rtcClock = setDisplayTime(key, rtcClock, 11, 1);
      rtc.setTime (rtcClock.hour, rtcClock.min, 0);
    }
  }  
  
  //Grundeinstellung & Tag
  if (MenuTiefe == 3 && MenuEbene0 == 1 && MenuEbene1 == 3)
  {
    //lcd.blink();
    if (FirstSelect)
    {
      setDisplayDow(-1, 5, 1);
      FirstSelect = false;
    }
    else
    {
      setDisplayDow(key, 5, 1);
    }
  }  

  
  ///////////////////////////////////////////////////////////////// D O S I E R P U M P E N E I N S T E L L U N G E N ///////////////////////////////////////////////////////////
  //---------------------------------------D O S I E R P U M P E 1----------------------------------------------
    //Manuelle Steuerung fuer Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 1 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiermanuell_1 = setDisplayBoolean2 (-1, Dosiermanuell_1, 11, 1);
      }
      else
        Dosiermanuell_1 = setDisplayBoolean2 (key, Dosiermanuell_1, 11, 1);
        EEPROM.writeByte(10, Dosiermanuell_1);
    }   
   
    //Kalibrierungswert von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 2 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Kalibrierung1 = setDisplayInteger (-1, Kalibrierung1, 0, 1000, false, 9, 1);
      }
      else
        Kalibrierung1 = setDisplayInteger (key, Kalibrierung1, 0, 1000, false, 9, 1);
        EEPROM.writeInt(11, Kalibrierung1);
    }   
  
    //Fahre eine fest gesetzte Pumpszeit für Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 2 && MenuEbene3 == 2)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Endtime1 = TimeStamp (-1, 60, Endtime1, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit, Column, Row
      }
      else
        Endtime1 = TimeStamp (key, 60, Endtime1, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit , Column, Row
    } 

    //Nachfüllautomatik Dosierer 1 (An/Aus)
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 3 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiernachfuell_1 = setDisplayBoolean2 (-1, Dosiernachfuell_1, 12, 1);
      }
      else
        Dosiernachfuell_1 = setDisplayBoolean2 (key, Dosiernachfuell_1, 12, 1);
        EEPROM.writeByte(13, Dosiernachfuell_1);
        
        if (Dosiernachfuell_1 == true)
        {
          Dosiernachfuell_2 = false;
          Dosiernachfuell_3 = false;
          Dosiernachfuell_4 = false;
          EEPROM.writeByte(60, 0);
          EEPROM.writeByte(107, 0);
          EEPROM.writeByte(154, 0);
        }
        
    }    
 
    //Zu dosierende Menge Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosiermenge1 = setDisplayInteger (-1, Dosiermenge1, 0, 1000, false, 11, 1);
      }
      else
        Dosiermenge1 = setDisplayInteger (key, Dosiermenge1, 0, 1000, false, 11, 1);
        EEPROM.writeLong(14, Dosiermenge1);
    }    
    
    //Uhrzeit 1 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 2)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_1 = setDisplayTime (-1, Dosierung1_1, 11, 1);
      }
      else
        Dosierung1_1 = setDisplayTime (key, Dosierung1_1, 11, 1);
        EEPROM.writeInt(17, Dosierung1_1.hour);
        EEPROM.writeInt(19, Dosierung1_1.min);
    }   
    
    //Uhrzeit 2 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 3)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_2 = setDisplayTime (-1, Dosierung1_2, 11, 1);
      }
      else
        Dosierung1_2 = setDisplayTime (key, Dosierung1_2, 11, 1);
        EEPROM.writeInt(21, Dosierung1_2.hour);
        EEPROM.writeInt(23, Dosierung1_2.min);
    }   
    
    //Uhrzeit 3 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 4)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_3 = setDisplayTime (-1, Dosierung1_3, 11, 1);
      }
      else
        Dosierung1_3 = setDisplayTime (key, Dosierung1_3, 11, 1);
        EEPROM.writeInt(25, Dosierung1_3.hour);
        EEPROM.writeInt(27, Dosierung1_3.min);
    }   
    
    //Uhrzeit 4 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 5)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_4 = setDisplayTime (-1, Dosierung1_4, 11, 1);
      }
      else
        Dosierung1_4 = setDisplayTime (key, Dosierung1_4, 11, 1);
        EEPROM.writeInt(29, Dosierung1_4.hour);
        EEPROM.writeInt(31, Dosierung1_4.min);
    }   
    
    //Uhrzeit 5 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 6)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_5 = setDisplayTime (-1, Dosierung1_5, 11, 1);
      }
      else
        Dosierung1_5 = setDisplayTime (key, Dosierung1_5, 11, 1);
        EEPROM.writeInt(33, Dosierung1_5.hour);
        EEPROM.writeInt(35, Dosierung1_5.min);
    }   
    
    //Uhrzeit 6 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 7)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_6 = setDisplayTime (-1, Dosierung1_6, 11, 1);
      }
      else
        Dosierung1_6 = setDisplayTime (key, Dosierung1_6, 11, 1);
        EEPROM.writeInt(37, Dosierung1_6.hour);
        EEPROM.writeInt(39, Dosierung1_6.min);
    }   
    
    //Uhrzeit 7 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 8)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_7 = setDisplayTime (-1, Dosierung1_7, 11, 1);
      }
      else
        Dosierung1_7 = setDisplayTime (key, Dosierung1_7, 11, 1);
        EEPROM.writeInt(41, Dosierung1_7.hour);
        EEPROM.writeInt(43, Dosierung1_7.min);
    }   
    
    //Uhrzeit 8 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 9)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_8 = setDisplayTime (-1, Dosierung1_8, 11, 1);
      }
      else
        Dosierung1_8 = setDisplayTime (key, Dosierung1_8, 11, 1);
        EEPROM.writeInt(45, Dosierung1_8.hour);
        EEPROM.writeInt(47, Dosierung1_8.min);
    }   
    
    //Uhrzeit 9 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 10)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_9 = setDisplayTime (-1, Dosierung1_9, 11, 1);
      }
      else
        Dosierung1_9 = setDisplayTime (key, Dosierung1_9, 11, 1);
        EEPROM.writeInt(49, Dosierung1_9.hour);
        EEPROM.writeInt(51, Dosierung1_9.min);
    }   
    
    //Uhrzeit 10 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 11)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_10 = setDisplayTime (-1, Dosierung1_10, 11, 1);
      }
      else
        Dosierung1_10 = setDisplayTime (key, Dosierung1_10, 11, 1);
        EEPROM.writeInt(53, Dosierung1_10.hour);
        EEPROM.writeInt(55, Dosierung1_10.min);
    }   
    //Uhrzeit 11 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 12)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_11 = setDisplayTime (-1, Dosierung1_11, 11, 1);
      }
      else
        Dosierung1_11 = setDisplayTime (key, Dosierung1_11, 11, 1);
        EEPROM.writeInt(53, Dosierung1_11.hour);
        EEPROM.writeInt(55, Dosierung1_11.min);
    }   
    //Uhrzeit 12 zur Dosierung von Dosierpumpe 1
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 1 && MenuEbene2 == 4 && MenuEbene3 == 13)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung1_12 = setDisplayTime (-1, Dosierung1_12, 11, 1);
      }
      else
        Dosierung1_12 = setDisplayTime (key, Dosierung1_12, 11, 1);
        EEPROM.writeInt(53, Dosierung1_12.hour);
        EEPROM.writeInt(55, Dosierung1_12.min);
    }   
    //----------------------------- bis hier hin Dosierer 1-----------------------------------------------------------------------
    
    //---------------------------------------D O S I E R P U M P E 2----------------------------------------------
    //Manuelle Steuerung fuer Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 1 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiermanuell_2 = setDisplayBoolean2 (-1, Dosiermanuell_2, 11, 1);
      }
      else
        Dosiermanuell_2 = setDisplayBoolean2 (key, Dosiermanuell_2, 11, 1);
        EEPROM.writeByte(57, Dosiermanuell_2);
    }   
   
    //Kalibrierungswert von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 2 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Kalibrierung2 = setDisplayInteger (-1, Kalibrierung2, 0, 1000, false, 9, 1);
      }
      else
        Kalibrierung2 = setDisplayInteger (key, Kalibrierung2, 0, 1000, false, 9, 1);
        EEPROM.writeInt(58, Kalibrierung2);
    }   
  
    //Fahre eine fest gesetzte Pumpszeit für Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 2 && MenuEbene3 == 2)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Endtime2 = TimeStamp (-1, 60, Endtime2, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit, Column, Row
      }
      else
        Endtime2 = TimeStamp (key, 60, Endtime2, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit , Column, Row
    } 

    //Nachfüllautomatik Dosierer 2 (An/Aus)
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 3 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiernachfuell_2 = setDisplayBoolean2 (-1, Dosiernachfuell_2, 12, 1);
      }
      else
        Dosiernachfuell_2 = setDisplayBoolean2 (key, Dosiernachfuell_2, 12, 1);
        EEPROM.writeByte(60, Dosiernachfuell_2);
        
        if (Dosiernachfuell_2 == true)
        {
          Dosiernachfuell_1 = false;
          Dosiernachfuell_3 = false;
          Dosiernachfuell_4 = false;
          EEPROM.writeByte(13, 0);
          EEPROM.writeByte(107, 0);
          EEPROM.writeByte(154, 0);
        }
    }    
 
    //Zu dosierende Menge Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosiermenge2 = setDisplayInteger (-1, Dosiermenge2, 0, 1000, false, 11, 1);
      }
      else
        Dosiermenge2 = setDisplayInteger (key, Dosiermenge2, 0, 1000, false, 11, 1);
        EEPROM.writeLong(61, Dosiermenge2);
    }    
    
    //Uhrzeit 1 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 2)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_1 = setDisplayTime (-1, Dosierung2_1, 11, 1);
      }
      else
        Dosierung2_1 = setDisplayTime (key, Dosierung2_1, 11, 1);
        EEPROM.writeInt(64, Dosierung2_1.hour);
        EEPROM.writeInt(66, Dosierung2_1.min);
    }   
    
    //Uhrzeit 2 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 3)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_2 = setDisplayTime (-1, Dosierung2_2, 11, 1);
      }
      else
        Dosierung2_2 = setDisplayTime (key, Dosierung2_2, 11, 1);
        EEPROM.writeInt(68, Dosierung2_2.hour);
        EEPROM.writeInt(70, Dosierung2_2.min);
    }   
    
    //Uhrzeit 3 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 4)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_3 = setDisplayTime (-1, Dosierung2_3, 11, 1);
      }
      else
        Dosierung2_3 = setDisplayTime (key, Dosierung2_3, 11, 1);
        EEPROM.writeInt(72, Dosierung2_3.hour);
        EEPROM.writeInt(74, Dosierung2_3.min);
    }   
    
    //Uhrzeit 4 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 5)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_4 = setDisplayTime (-1, Dosierung2_4, 11, 1);
      }
      else
        Dosierung2_4 = setDisplayTime (key, Dosierung2_4, 11, 1);
        EEPROM.writeInt(76, Dosierung2_4.hour);
        EEPROM.writeInt(78, Dosierung2_4.min);
    }   
    
    //Uhrzeit 5 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 6)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_5 = setDisplayTime (-1, Dosierung2_5, 11, 1);
      }
      else
        Dosierung2_5 = setDisplayTime (key, Dosierung2_5, 11, 1);
        EEPROM.writeInt(80, Dosierung2_5.hour);
        EEPROM.writeInt(82, Dosierung2_5.min);
    }   
    
    //Uhrzeit 6 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 7)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_6 = setDisplayTime (-1, Dosierung2_6, 11, 1);
      }
      else
        Dosierung2_6 = setDisplayTime (key, Dosierung2_6, 11, 1);
        EEPROM.writeInt(84, Dosierung2_6.hour);
        EEPROM.writeInt(86, Dosierung2_6.min);
    }   
    
    //Uhrzeit 7 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 8)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_7 = setDisplayTime (-1, Dosierung2_7, 11, 1);
      }
      else
        Dosierung2_7 = setDisplayTime (key, Dosierung2_7, 11, 1);
        EEPROM.writeInt(88, Dosierung2_7.hour);
        EEPROM.writeInt(90, Dosierung2_7.min);
    }   
    
    //Uhrzeit 8 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 9)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_8 = setDisplayTime (-1, Dosierung2_8, 11, 1);
      }
      else
        Dosierung2_8 = setDisplayTime (key, Dosierung2_8, 11, 1);
        EEPROM.writeInt(92, Dosierung2_8.hour);
        EEPROM.writeInt(94, Dosierung2_8.min);
    }   
    
    //Uhrzeit 9 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 10)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_9 = setDisplayTime (-1, Dosierung2_9, 11, 1);
      }
      else
        Dosierung2_9 = setDisplayTime (key, Dosierung2_9, 11, 1);
        EEPROM.writeInt(96, Dosierung2_9.hour);
        EEPROM.writeInt(98, Dosierung2_9.min);
    }   
    
    //Uhrzeit 10 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 11)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_10 = setDisplayTime (-1, Dosierung2_10, 11, 1);
      }
      else
        Dosierung2_10 = setDisplayTime (key, Dosierung2_10, 11, 1);
        EEPROM.writeInt(100, Dosierung2_10.hour);
        EEPROM.writeInt(102, Dosierung2_10.min);
    } 
    
    //Uhrzeit 11 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 12)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_11 = setDisplayTime (-1, Dosierung2_11, 11, 1);
      }
      else
        Dosierung2_11 = setDisplayTime (key, Dosierung2_11, 11, 1);
        EEPROM.writeInt(100, Dosierung2_11.hour);
        EEPROM.writeInt(102, Dosierung2_11.min);
    }   
    
    //Uhrzeit 12 zur Dosierung von Dosierpumpe 2
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 2 && MenuEbene2 == 4 && MenuEbene3 == 13)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung2_12 = setDisplayTime (-1, Dosierung2_12, 11, 1);
      }
      else
        Dosierung2_12 = setDisplayTime (key, Dosierung2_12, 11, 1);
        EEPROM.writeInt(100, Dosierung2_12.hour);
        EEPROM.writeInt(102, Dosierung2_12.min);
    }   
    //----------------------------- bis hier hin Dosierer 2-----------------------------------------------------------------------
    
    //---------------------------------------D O S I E R P U M P E 3----------------------------------------------
    //Manuelle Steuerung fuer Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 1 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiermanuell_3 = setDisplayBoolean2 (-1, Dosiermanuell_3, 11, 1);
      }
      else
        Dosiermanuell_3 = setDisplayBoolean2 (key, Dosiermanuell_3, 11, 1);
        EEPROM.writeByte(104, Dosiermanuell_3);
    }   
   
    //Kalibrierungswert von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 2 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Kalibrierung3 = setDisplayInteger (-1, Kalibrierung3, 0, 1000, false, 9, 1);
      }
      else
        Kalibrierung3 = setDisplayInteger (key, Kalibrierung3, 0, 1000, false, 9, 1);
        EEPROM.writeInt(105, Kalibrierung3);
    }   
  
    //Fahre eine fest gesetzte Pumpszeit für Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 2 && MenuEbene3 == 2)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Endtime3 = TimeStamp (-1, 60, Endtime3, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit, Column, Row
      }
      else
        Endtime3 = TimeStamp (key, 60, Endtime3, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit , Column, Row
    } 

    //Nachfüllautomatik Dosierer 3 (An/Aus)
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 3 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiernachfuell_3 = setDisplayBoolean2 (-1, Dosiernachfuell_3, 12, 1);
      }
      else
        Dosiernachfuell_3 = setDisplayBoolean2 (key, Dosiernachfuell_3, 12, 1);
        EEPROM.writeByte(107, Dosiernachfuell_3);
        
        if (Dosiernachfuell_3 == true)
        {
          Dosiernachfuell_1 = false;
          Dosiernachfuell_2 = false;
          Dosiernachfuell_4 = false;
          EEPROM.writeByte(13, 0);
          EEPROM.writeByte(60, 0);
          EEPROM.writeByte(154, 0);
        }
    }    
 
    //Zu dosierende Menge Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosiermenge3 = setDisplayInteger (-1, Dosiermenge3, 0, 1000, false, 11, 1);
      }
      else
        Dosiermenge3 = setDisplayInteger (key, Dosiermenge3, 0, 1000, false, 11, 1);
        EEPROM.writeLong(108, Dosiermenge3);
    }    
    
    //Uhrzeit 1 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 2)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_1 = setDisplayTime (-1, Dosierung3_1, 11, 1);
      }
      else
        Dosierung3_1 = setDisplayTime (key, Dosierung3_1, 11, 1);
        EEPROM.writeInt(111, Dosierung3_1.hour);
        EEPROM.writeInt(113, Dosierung3_1.min);
    }   
    
    //Uhrzeit 2 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 3)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_2 = setDisplayTime (-1, Dosierung3_2, 11, 1);
      }
      else
        Dosierung3_2 = setDisplayTime (key, Dosierung3_2, 11, 1);
        EEPROM.writeInt(115, Dosierung3_2.hour);
        EEPROM.writeInt(117, Dosierung3_2.min);
    }   
    
    //Uhrzeit 3 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 4)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_3 = setDisplayTime (-1, Dosierung3_3, 11, 1);
      }
      else
        Dosierung3_3 = setDisplayTime (key, Dosierung3_3, 11, 1);
        EEPROM.writeInt(119, Dosierung3_3.hour);
        EEPROM.writeInt(121, Dosierung3_3.min);
    }   
    
    //Uhrzeit 4 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 5)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_4 = setDisplayTime (-1, Dosierung3_4, 11, 1);
      }
      else
        Dosierung3_4 = setDisplayTime (key, Dosierung3_4, 11, 1);
        EEPROM.writeInt(123, Dosierung3_4.hour);
        EEPROM.writeInt(125, Dosierung3_4.min);
    }   
    
    //Uhrzeit 5 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 6)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_5 = setDisplayTime (-1, Dosierung3_5, 11, 1);
      }
      else
        Dosierung3_5 = setDisplayTime (key, Dosierung3_5, 11, 1);
        EEPROM.writeInt(127, Dosierung3_5.hour);
        EEPROM.writeInt(129, Dosierung3_5.min);
    }   
    
    //Uhrzeit 6 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 7)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_6 = setDisplayTime (-1, Dosierung3_6, 11, 1);
      }
      else
        Dosierung3_6 = setDisplayTime (key, Dosierung3_6, 11, 1);
        EEPROM.writeInt(131, Dosierung3_6.hour);
        EEPROM.writeInt(133, Dosierung3_6.min);
    }   
    
    //Uhrzeit 7 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 8)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_7 = setDisplayTime (-1, Dosierung3_7, 11, 1);
      }
      else
        Dosierung3_7 = setDisplayTime (key, Dosierung3_7, 11, 1);
        EEPROM.writeInt(135, Dosierung3_7.hour);
        EEPROM.writeInt(137, Dosierung3_7.min);
    }   
    
    //Uhrzeit 8 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 9)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_8 = setDisplayTime (-1, Dosierung3_8, 11, 1);
      }
      else
        Dosierung3_8 = setDisplayTime (key, Dosierung3_8, 11, 1);
        EEPROM.writeInt(139, Dosierung3_8.hour);
        EEPROM.writeInt(141, Dosierung3_8.min);
    }   
    
    //Uhrzeit 9 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 10)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_9 = setDisplayTime (-1, Dosierung3_9, 11, 1);
      }
      else
        Dosierung3_9 = setDisplayTime (key, Dosierung3_9, 11, 1);
        EEPROM.writeInt(143, Dosierung3_9.hour);
        EEPROM.writeInt(145, Dosierung3_9.min);
    }   
    
    //Uhrzeit 10 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 11)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_10 = setDisplayTime (-1, Dosierung3_10, 11, 1);
      }
      else
        Dosierung3_10 = setDisplayTime (key, Dosierung3_10, 11, 1);
        EEPROM.writeInt(147, Dosierung3_10.hour);
        EEPROM.writeInt(149, Dosierung3_10.min);
    }   
    
    //Uhrzeit 11 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 12)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_11 = setDisplayTime (-1, Dosierung3_11, 11, 1);
      }
      else
        Dosierung3_11 = setDisplayTime (key, Dosierung3_11, 11, 1);
        EEPROM.writeInt(147, Dosierung3_11.hour);
        EEPROM.writeInt(149, Dosierung3_11.min);
    }   
    
    //Uhrzeit 12 zur Dosierung von Dosierpumpe 3
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 3 && MenuEbene2 == 4 && MenuEbene3 == 13)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung3_12 = setDisplayTime (-1, Dosierung3_12, 11, 1);
      }
      else
        Dosierung3_12 = setDisplayTime (key, Dosierung3_12, 11, 1);
        EEPROM.writeInt(147, Dosierung3_12.hour);
        EEPROM.writeInt(149, Dosierung3_12.min);
    }   
    //----------------------------- bis hier hin Dosierer 3-----------------------------------------------------------------------
    
    
    //---------------------------------------D O S I E R P U M P E 4----------------------------------------------
    //Manuelle Steuerung fuer Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 1 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiermanuell_4 = setDisplayBoolean2 (-1, Dosiermanuell_4, 11, 1);
      }
      else
        Dosiermanuell_4 = setDisplayBoolean2 (key, Dosiermanuell_4, 11, 1);
        EEPROM.writeByte(151, Dosiermanuell_4);
    }   
   
    //Kalibrierungswert von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 2 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Kalibrierung4 = setDisplayInteger (-1, Kalibrierung4, 0, 1000, false, 9, 1);
      }
      else
        Kalibrierung4 = setDisplayInteger (key, Kalibrierung4, 0, 1000, false, 9, 1);
        EEPROM.writeInt(152, Kalibrierung4);
    }   
  
    //Fahre eine fest gesetzte Pumpszeit für Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 2 && MenuEbene3 == 2)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Endtime4 = TimeStamp (-1, 60, Endtime4, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit, Column, Row
      }
      else
        Endtime4 = TimeStamp (key, 60, Endtime4, 0, 1); //Select Key, Dauer der manuell gesetzten Rotation [sek], Einfrieren einer Zeit , Column, Row
    } 

    //Nachfüllautomatik Dosierer 4 (An/Aus)
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 3 && MenuEbene3 == 1)
    {
      //lcd.blink();
      if (FirstSelect)
      { 
        FirstSelect = false;
        Dosiernachfuell_4 = setDisplayBoolean2 (-1, Dosiernachfuell_4, 12, 1);
      }
      else
        Dosiernachfuell_4 = setDisplayBoolean2 (key, Dosiernachfuell_4, 12, 1);
        EEPROM.writeByte(154, Dosiernachfuell_4);
        
        if (Dosiernachfuell_4 == true)
        {
          Dosiernachfuell_1 = false;
          Dosiernachfuell_2 = false;
          Dosiernachfuell_3 = false;
          EEPROM.writeByte(13, 0);
          EEPROM.writeByte(60, 0);
          EEPROM.writeByte(107, 0);
        }
    }    
 
    //Zu dosierende Menge Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 1)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosiermenge4 = setDisplayInteger (-1, Dosiermenge4, 0, 1000, false, 11, 1);
      }
      else
        Dosiermenge4 = setDisplayInteger (key, Dosiermenge4, 0, 1000, false, 11, 1);
        EEPROM.writeLong(155, Dosiermenge4);
    }    
    
    //Uhrzeit 1 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 2)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_1 = setDisplayTime (-1, Dosierung4_1, 11, 1);
      }
      else
        Dosierung4_1 = setDisplayTime (key, Dosierung4_1, 11, 1);
        EEPROM.writeInt(158, Dosierung4_1.hour);
        EEPROM.writeInt(160, Dosierung4_1.min);
    }   
    
    //Uhrzeit 2 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 3)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_2 = setDisplayTime (-1, Dosierung4_2, 11, 1);
      }
      else
        Dosierung4_2 = setDisplayTime (key, Dosierung4_2, 11, 1);
        EEPROM.writeInt(162, Dosierung4_2.hour);
        EEPROM.writeInt(164, Dosierung4_2.min);
    }   
    
    //Uhrzeit 3 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 4)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_3 = setDisplayTime (-1, Dosierung4_3, 11, 1);
      }
      else
        Dosierung4_3 = setDisplayTime (key, Dosierung4_3, 11, 1);
        EEPROM.writeInt(166, Dosierung4_3.hour);
        EEPROM.writeInt(168, Dosierung4_3.min);
    }   
    
    //Uhrzeit 4 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 5)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_4 = setDisplayTime (-1, Dosierung4_4, 11, 1);
      }
      else
        Dosierung4_4 = setDisplayTime (key, Dosierung4_4, 11, 1);
        EEPROM.writeInt(170, Dosierung4_4.hour);
        EEPROM.writeInt(172, Dosierung4_4.min);
    }   
    
    //Uhrzeit 5 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 6)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_5 = setDisplayTime (-1, Dosierung4_5, 11, 1);
      }
      else
        Dosierung4_5 = setDisplayTime (key, Dosierung4_5, 11, 1);
        EEPROM.writeInt(174, Dosierung4_5.hour);
        EEPROM.writeInt(176, Dosierung4_5.min);
    }   
    
    //Uhrzeit 6 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 7)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_6 = setDisplayTime (-1, Dosierung4_6, 11, 1);
      }
      else
        Dosierung4_6 = setDisplayTime (key, Dosierung4_6, 11, 1);
        EEPROM.writeInt(178, Dosierung4_6.hour);
        EEPROM.writeInt(180, Dosierung4_6.min);
    }   
    
    //Uhrzeit 7 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 8)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_7 = setDisplayTime (-1, Dosierung4_7, 11, 1);
      }
      else
        Dosierung4_7 = setDisplayTime (key, Dosierung4_7, 11, 1);
        EEPROM.writeInt(182, Dosierung4_7.hour);
        EEPROM.writeInt(184, Dosierung4_7.min);
    }   
    
    //Uhrzeit 8 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 9)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_8 = setDisplayTime (-1, Dosierung4_8, 11, 1);
      }
      else
        Dosierung4_8 = setDisplayTime (key, Dosierung4_8, 11, 1);
        EEPROM.writeInt(186, Dosierung4_8.hour);
        EEPROM.writeInt(188, Dosierung4_8.min);
    }   
    
    //Uhrzeit 9 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 10)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_9 = setDisplayTime (-1, Dosierung4_9, 11, 1);
      }
      else
        Dosierung4_9 = setDisplayTime (key, Dosierung4_9, 11, 1);
        EEPROM.writeInt(190, Dosierung4_9.hour);
        EEPROM.writeInt(192, Dosierung4_9.min);
    }   
    
    //Uhrzeit 10 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 11)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_10 = setDisplayTime (-1, Dosierung4_10, 11, 1);
      }
      else
        Dosierung4_10 = setDisplayTime (key, Dosierung4_10, 11, 1);
        EEPROM.writeInt(194, Dosierung4_10.hour);
        EEPROM.writeInt(196, Dosierung4_10.min);
    }   
    
    //Uhrzeit 11 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 12)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_11 = setDisplayTime (-1, Dosierung4_11, 11, 1);
      }
      else
        Dosierung4_11 = setDisplayTime (key, Dosierung4_11, 11, 1);
        EEPROM.writeInt(194, Dosierung4_11.hour);
        EEPROM.writeInt(196, Dosierung4_11.min);
    }   
    
    //Uhrzeit 12 zur Dosierung von Dosierpumpe 4
    if (MenuTiefe == 5 && MenuEbene0 == 2 && MenuEbene1 == 4 && MenuEbene2 == 4 && MenuEbene3 == 13)
    {
      lcd.blink();
      if (FirstSelect)
      {
        FirstSelect = false;
        Dosierung4_12 = setDisplayTime (-1, Dosierung4_12, 11, 1);
      }
      else
        Dosierung4_12 = setDisplayTime (key, Dosierung4_12, 11, 1);
        EEPROM.writeInt(194, Dosierung4_12.hour);
        EEPROM.writeInt(196, Dosierung4_12.min);
    }   
    //----------------------------- bis hier hin Dosierer 4-----------------------------------------------------------------------
    
    
 
    
   
    
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
      

}

